local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- character's custom assets
        Asset( "ANIM", "anim/reaper.zip" ),
        Asset( "ANIM", "anim/reaperold.zip" ),
		Asset( "ANIM", "anim/ghost_reaper_build.zip" ),
		Asset( "SOUND", "sound/reaper.fsb"),
}

local prefabs = 

{
        "scythe",
}

local start_inv =
{
		"scythe",
}

local function common_postinit(inst)

	inst.soundsname = "reaper"

	inst.MiniMapEntity:SetIcon( "reaper.tex" )
	
	inst:AddTag("scythe_owner")

	
end
	
local function lighton(inst, data) --light aura
if TheWorld.state.isnight  then
	local light = inst.entity:AddLight()
	inst.Light:Enable(true)
	inst.Light:SetRadius(0.5)
	inst.Light:SetFalloff(.4)
	inst.Light:SetIntensity(.5)
	inst.Light:SetColour(197/255, 197/255, 50/255)
	
elseif TheWorld.state.isday then
	local light = inst.entity:AddLight()
	light:SetIntensity(0)
	light:SetRadius(0)
	light:SetFalloff(0)
	light:Enable(false)
	light:SetColour(0/255, 0/255, 0/255)
	
elseif TheWorld.state.isdusk then
	local light = inst.entity:AddLight()
	light:SetIntensity(0)
	light:SetRadius(0)
	light:SetFalloff(0)
	light:Enable(false)
	light:SetColour(0/255, 0/255, 0/255)
	end
end

	-------
	local function IsValidVictim(victim)
    return victim ~= nil
        and not (victim:HasTag("prey") or
                victim:HasTag("veggie") or
                victim:HasTag("structure") or
                victim:HasTag("companion"))
        and victim.components.health ~= nil
        and victim.components.combat ~= nil
end
	-------
	local function onattack(inst, data) --get health and sanity when killing enemies
   local victim = data.target
    if not inst.components.health:IsDead() and IsValidVictim(victim) then
		local healthdelta = (victim.components.combat.defaultdamage * .12)
        local sanitydelta = (victim.components.combat.defaultdamage * .17)
        inst.components.health:DoDelta(healthdelta)
        inst.components.sanity:DoDelta(sanitydelta)
	end
end


	-------
local function onnewstats(inst, data)
	if TheWorld.state.isday then
	inst.components.combat.damagemultiplier = 1
	elseif TheWorld.state.isdusk then
	inst.components.combat.damagemultiplier = 1.35
	elseif TheWorld.state.isnight then
	inst.components.combat.damagemultiplier = 1.8
end
end
	-------
local function onsetskin(inst)
 if ReaperLook == "newlook" then
inst.AnimState:SetBuild("reaper")
else
inst.AnimState:SetBuild("reaperold")
end
end
	-------
	
local function master_postinit(inst)
	
	inst.components.health:SetMaxHealth(130)
	inst.components.hunger:SetMax(250)
	inst.components.sanity:SetMax(130)
	
	-----
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.2)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.2)
	inst.components.eater.strongstomach = false
	inst.components.combat.defaultdamage = 34
	inst.components.sanity.night_drain_mult = 0
--- inst.components.temperature.mintemp = 1 -- stop freezing
	inst.components.health.fire_damage_scale = 1.7
	inst.components.temperature.hurtrate = 120 / TUNING.FREEZING_KILL_TIME * 0.4 --slower freezing
	-----

	-----
	inst:ListenForEvent("sanitydelta", lighton)
	inst:ListenForEvent("respawnfromghost")
    inst:ListenForEvent("newstate", onnewstats)
    inst:ListenForEvent("onattackother", onattack)
	
 ---inst.components.locomotor:SetTriggersCreep(false)
 


inst.OnSetSkin = onsetskin


inst.components.sanity.custom_rate_fn = function() 
		if TheWorld.state.isnight then
	return 0
	elseif TheWorld.state.isday then
		return -4.5/60
	elseif TheWorld.state.isdusk then
		return 0
	end
end
	end
			
return MakePlayerCharacter("reaper", prefabs, assets, common_postinit, master_postinit, start_inv)